local e=require"luci.http"
local n=require"nixio"
local i=require"luci.ltn12"
local h=require"table"
local a=require"luci.util"
module("luci.controller.linkease_backend",package.seeall)
local t=2048
local s="/var/run/linkease.sock"
function index()
entry({"linkease"},call("linkease_backend")).leaf=true
end
local function r(e,a)
if e then
return function(t,a)
if not t then
return 1
else
return e:send(t)
end
end
else
return i.sink.error(a or"unable to send socket")
end
end
local function d(o,t)
local e=a.ubus("session","get",{ubus_rpc_session=o})
if type(e)=="table"and
type(e.values)=="table"and
type(e.values.token)=="string"and
(not t or
a.contains(t,e.values.username))
then
return o,e.values
end
return nil,nil
end
local function l()
local t
local a
local a
for i,o in ipairs({"sysauth_https","sysauth_http","sysauth"})do
t=e.getcookie(o)
if t then
t,a=d(t,nil)
if t and a then
return t,a
end
end
end
return nil,nil
end
local function d(i,t)
t=t or""
return function()
local o
local n,a,e=t:find("^([0-9a-fA-F]+);?.-\r\n")
while not e and#t<=1024 do
local o,i=i:recv(1024-#t)
if not o then
return nil,i
end
t=t..o
n,a,e=t:find("^([0-9a-fA-F]+);?.-\r\n")
end
e=tonumber(e,16)
if not e then
return nil,-1,"invalid encoding"
elseif e==0 then
return nil
elseif e+2<=#t-a then
o=t:sub(a+1,a+e)
t=t:sub(a+e+3)
return o
else
o=t:sub(a+1,a+e)
t=""
if e-#o>0 then
local a,t=i:recvall(e-#o)
if not a then
return nil,t
end
o=o..a
e,t=i:recvall(2)
else
e,code=i:recvall(e+2-#t+a)
end
if not e then
return nil,code
end
return o
end
end
end
function linkease_backend()
local a=n.socket("unix","stream")
if a:connect(s)~=true then
e.status(500,"connect failed")
return
end
local t={}
t[#t+1]=e.getenv("REQUEST_METHOD").." "..e.getenv("REQUEST_URI").." HTTP/1.1"
local u=e.context.request
local s="HTTP_"
local n=string.len(s)
local o=e.getenv("CONTENT_TYPE")
if o then
t[#t+1]="Content-Type: "..o
end
for e,a in pairs(u.message.env)do
if string.sub(e,1,n)==s and not string.find(e,"FORWARDED")then
t[#t+1]=string.sub(e,n+1,string.len(e))..": "..a
end
end
local n,o=l()
if o~=nil then
t[#t+1]="X-Forwarded-Sid: "..n
t[#t+1]="X-Forwarded-Token: "..o.token
end
local n=tonumber(e.getenv("CONTENT_LENGTH"))or 0
t[#t+1]="Content-Length: "..tostring(n)
t[#t+1]="\r\n"
local t=i.source.cat(i.source.string(h.concat(t,"\r\n")),e.source())
local t=i.pump.all(t,r(a,"write sock error"))
if t~=1 then
a:close()
e.status(500,"proxy error")
return
end
local o=a:linesource()
local t,s,s=o()
if not t then
a:close()
e.status(500,"response parse failed")
return
end
local r,h,s=t:match("^([%w./]+) ([0-9]+) (.*)")
if not r then
a:close()
e.status(500,"response protocol error")
return
end
n=tonumber(h)or 0
e.status(n,s)
local s=e.getenv("SERVER_SOFTWARE")~="uhttpd"
local n=0
t=o()
while t and t~=""do
local a,i=t:match("^([%w-]+)%s?:%s?(.*)")
if a and a~="Status"then
if a=="Transfer-Encoding"and i=="chunked"then
n=1
end
if a~="Connection"and a~="Transfer-Encoding"and(s or(a~="Content-Length"and a~="Accept-Ranges"))then
e.header(a,i)
end
end
t=o()
end
if not t then
a:close()
e.status(500,"parse header failed")
return
end
local t=o(true)
if n==1 then
i.pump.all(d(a,t),e.write)
else
local t=i.source.cat(i.source.string(t),a:blocksource())
i.pump.all(t,e.write)
end
a:close()
end
